SystemOrganization addCategory: #ConfigurationOfMerchant!

Object subclass: #ConfigurationOfMerchant
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMerchant'!

!ConfigurationOfMerchant class methodsFor: 'development support' stamp: 'sebastiansastre 3/4/2014 10:47'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMerchant class methodsFor: 'private' stamp: 'sebastiansastre 3/4/2014 10:47'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMerchant class methodsFor: 'catalog' stamp: 'sebastiansastre 3/12/2014 17:07'!
catalogChangeLog
	^ '
Date: March 12, 2014

First Merchant configuration using github

'! !

!ConfigurationOfMerchant class methodsFor: 'catalog' stamp: 'sebastiansastre 3/4/2014 10:54'!
catalogContactInfo
	^ 'https://github.com/sebastianconcept'! !

!ConfigurationOfMerchant class methodsFor: 'catalog' stamp: 'sebastiansastre 3/12/2014 17:07'!
catalogDescription
	^ 'Merchant is a credit card processing library. Used by airflowing an application from flowing.'! !

!ConfigurationOfMerchant class methodsFor: 'catalog' stamp: 'sebastiansastre 3/12/2014 17:08'!
catalogKeyClassesAndExample
	^ '

'! !

!ConfigurationOfMerchant class methodsFor: 'catalog' stamp: 'sebastiansastre 3/12/2014 17:09'!
catalogKeywords
	^ #(#Transaction #Payments #CreditCardProcessing)! !

!ConfigurationOfMerchant class methodsFor: 'gitfiletree support' stamp: 'sebastiansastre 3/4/2014 10:47'!
ensureGitFileTree
	"And all related dependencies."

	Smalltalk
		at: #MCFileTreeGitRepository
		ifAbsent: [ 
			Gofer new
				url: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main';
				configurationOf: 'GitFileTree';
				loadDevelopment ]! !

!ConfigurationOfMerchant class methodsFor: 'private' stamp: 'sebastiansastre 3/4/2014 10:47'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMerchant class methodsFor: 'private' stamp: 'sebastiansastre 3/4/2014 10:47'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMerchant class methodsFor: 'metacello tool support' stamp: 'sebastiansastre 3/4/2014 10:47'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMerchant class methodsFor: 'loading' stamp: 'sebastiansastre 3/4/2014 10:47'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMerchant class methodsFor: 'accessing' stamp: 'sebastiansastre 3/4/2014 10:47'!
project

	^self new project! !

!ConfigurationOfMerchant class methodsFor: 'development support' stamp: 'sebastiansastre 3/4/2014 10:47'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMerchant methodsFor: 'baselines' stamp: 'sebastiansastre 3/12/2014 17:31'!
baseline10: spec
    <version: '1.0-baseline'>
    
	spec for: #'pharo3.x' do: [
		self class ensureGitFileTree.
		spec blessing: #baseline.

		spec project: 'XMLSupport' with: [ spec
				className: 'ConfigurationOfXMLSupport';
				file: 'ConfigurationOfXMLSupport';
				repository: 'http://smalltalkhub.com/mc/PharoExtras/XMLSupport/main'.
				].
			
		spec
			package: 'HTML'  
				with: [ spec repository: 'http://smalltalkhub.com/mc/ToddBlanchard/HTMCSSValidatingParser/main' ]
				].			
! !

!ConfigurationOfMerchant methodsFor: 'baselines' stamp: 'sebastiansastre 5/12/2015 11:07'!
baseline11: spec
    <version: '1.1-baseline'>
    
	spec for: #'pharo4.x' do: [
		self class ensureGitFileTree.
		spec blessing: #baseline.

		spec project: 'XMLSupport' with: [ spec
				className: 'ConfigurationOfXMLSupport';
				file: 'ConfigurationOfXMLSupport';
				repository: 'http://smalltalkhub.com/mc/PharoExtras/XMLSupport/main'.
				].
			
		spec
			package: 'HTML'  
				with: [ spec repository: 'http://smalltalkhub.com/mc/ToddBlanchard/HTMCSSValidatingParser/main' ]
				].			
! !

!ConfigurationOfMerchant methodsFor: 'accessing' stamp: 'sebastiansastre 3/4/2014 10:47'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfMerchant methodsFor: 'accessing' stamp: 'sebastiansastre 3/4/2014 10:47'!
project
	^ project
		ifNil: [ 
			| constructor |
				"Bootstrap Metacello if it is not already loaded"
			(self class baseConfigurationClassIfAbsent: [  ]) ensureMetacello.
				"Construct Metacello project"
			project := MetacelloMCProject new projectAttributes: self customProjectAttributes.
			constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
			project loadType: #linear.	"change to #atomic if desired"
			project ]! !

!ConfigurationOfMerchant methodsFor: 'symbolic versions' stamp: 'sebastiansastre 5/12/2015 11:08'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo4.x' version: '1.1'
! !

!ConfigurationOfMerchant methodsFor: 'versions' stamp: 'sebastiansastre 3/12/2014 15:40'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec
		for: #'pharo3.x'
		do: [ 
			spec
				blessing: #release;
				author: 'sebastianconcept';
				repository: 'gitfiletree://github.com/sebastianconcept/Merchant.git?protocol=git&branch=Pharo3.0&dir=src';
				description: 'This is a credit card processing library. I needed this for airflowing an application from flowing.'.

			spec package: 'Merchant'.
			 ].
! !

!ConfigurationOfMerchant methodsFor: 'versions' stamp: 'sebastiansastre 5/12/2015 11:07'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>
	
	spec
		for: #'pharo4.x'
		do: [ 
			spec
				blessing: #release;
				author: 'sebastianconcept';
				repository: 'gitfiletree://github.com/sebastianconcept/Merchant.git?protocol=git&branch=Pharo4.0&dir=src';
				description: 'This is a credit card processing library. I needed this for airflowing an application from flowing.'.

			spec package: 'Merchant'.
			 ].
! !
